
#include <stdio.h>
#include <time.h>
#include <iostream> 
#include <iomanip>
#include <fstream>
#include <sstream>
#include <Windows.h>
#include <Winbase.h>
#include <ctime>
#include <cstdlib>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <math.h>
#include "DataPoints.h"


#define X 0
#define Y 1
#define Z 2
typedef std::numeric_limits< double > dbl;


int main(int argc, char* argv[]) 
{   
  char file_in[200], file_out[100], logfilename[100];
  strcpy(file_in, "F:\\Visual Studio 2010\\Projects\\CalibrateRawData\\magnpoints.txt");
  strcpy(file_out, "F:\\Visual Studio 2010\\Projects\\CalibrateRawData\\cal_magnpoints.txt");
  strcpy(logfilename, "F:\\Visual Studio 2010\\Projects\\CalibrateRawData\\calibration_log.txt");
  
  vector <DataPoint> record;

  
  double cal_matrix[3][3]={ {1.176619, -0.031289, -0.059603}, 
    {-0.031289, 1.042471, -0.002135}, 
  {-0.059603, -0.002135, 0.974423}} ;
  
  /*  Testing first the offset Values with A[] = 1 */
  /*
  double cal_matrix[3][3]={ {1, 0, 0}, 
                            {0, 1, 0}, 
                            {0, 0, 1}};
  */


  //double cal_offsets[3] = {-29.866156, -18.729712, 12.157101};
  double cal_offsets[3] = {29.866156, 18.729712, -12.157101};

  printf("CALIBRATION MATRIX\n");
  for(int l=0;l<3;l++)
  {
    for(int c=0; c<3; c++)
      printf("%lf\t", cal_matrix[l][c]);
    printf("\n");
  }

  std::ofstream outf( file_out, std::ofstream::trunc);  
  if( outf.is_open() == false)
    return -1;
  std::ofstream outlog( logfilename, std::ofstream::trunc);  
  if( outlog.is_open() == false)
    return -1;

  

  ifstream infile( file_in );
  int cnt=0;

  while (infile)
  {
    string s("");
    if (!getline( infile, s )) 
		break;
    istringstream ss( s );    
    if( s != string(""))
    {
	    double x, y, z;
	    if( sscanf(s.c_str(), "%lf\t%lf\t%lf", &x, &y, &z) == 3 )
      {
        double _x = x;
        double _y = y;
        double _z = z;
        outlog.precision(dbl::digits10);
        outf.precision(dbl::digits10);
        outlog << setprecision(5) << "X " << x << "\tY " << y << "\tZ " << z << "\t\t";
        x += cal_offsets[X];
        y += cal_offsets[Y];
        z += cal_offsets[Z];
        outlog << "offX " << x << "\toffY " << y << "\toffZ " << z << "\t\t";
		    //record.push_back( DataPoint(x, y, z) );
        double cal_x = cal_matrix[X][X]*x + cal_matrix[X][Y]*y + cal_matrix[X][Z]*z;
        double cal_y = cal_matrix[Y][X]*x + cal_matrix[Y][Y]*y + cal_matrix[Y][Z]*z;
        double cal_z = cal_matrix[Z][X]*x + cal_matrix[Z][Y]*y + cal_matrix[Z][Z]*z;        
        outf << setprecision(7) << cal_x << '\t' << cal_y << '\t' << cal_z << endl;
        outlog << "calX " << cal_x << "\tcalY " << cal_y << "\tcalZ " << cal_z << "\t\t";
        outlog << "deltaX " << _x-cal_x << "\tdeltaY " << _y-cal_y << "\tdeltaZ " << _z-cal_z << endl;
        printf(".");
      }
    }    
  }

  outlog.close();
  outf.close();
  return 0;  
}  
